#ifndef DROPLINE_STATUS_ICON_H
#define DROPLINE_STATUS_ICON_H

#include <gtk/gtk.h>
/*
 * We require also libnotify for the fancy notifications.
 */
#include <libnotify/notify.h>
/*
 * We use curl to retrieve stuff from internet.
 */
#include <curl/curl.h>

G_BEGIN_DECLS

#define DROPLINE_TYPE_STATUS_ICON            (dropline_status_icon_get_type())
#define DROPLINE_STATUS_ICON(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), DROPLINE_TYPE_STATUS_ICON, DroplineStatusIcon))
#define DROPLINE_STATUS_ICON_CONST(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), DROPLINE_TYPE_STATUS_ICON, DroplineStatusIcon const))
#define DROPLINE_STATUS_ICON_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  DROPLINE_TYPE_STATUS_ICON, DroplineStatusIconClass))
#define DROPLINE_IS_STATUS_ICON(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DROPLINE_TYPE_STATUS_ICON))
#define DROPLINE_IS_STATUS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  DROPLINE_TYPE_STATUS_ICON))
#define DROPLINE_STATUS_ICON_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  DROPLINE_TYPE_STATUS_ICON, DroplineStatusIconClass))

typedef struct _DroplineStatusIcon        DroplineStatusIcon;
typedef struct _DroplineStatusIconClass   DroplineStatusIconClass;
typedef struct _DroplineStatusIconPrivate DroplineStatusIconPrivate;

struct _DroplineStatusIcon
{
   GtkStatusIcon parent;

   /*< private >*/
   DroplineStatusIconPrivate *priv;
};

struct _DroplineStatusIconClass
{
   GtkStatusIconClass parent_class;
};

GType          dropline_status_icon_get_type (void) G_GNUC_CONST;
GtkStatusIcon *dropline_status_icon_new      (void);

G_END_DECLS

static void dlg_start_installer(NotifyNotification *, char *, gpointer);
static void dlg_preferences_window (GtkStatusIcon *, gpointer);
static void dlg_about_window (GtkWidget *, gpointer);
static void dlg_check_for_updates (GtkStatusIcon *, gpointer);
static void destroy (GtkWidget *, gpointer);
static void dlg_notify_cb (GtkWidget *, gpointer);
static void dlg_popup (GtkStatusIcon *, guint, guint, gpointer);

#endif /* DROPLINE_STATUS_ICON_H */
